; ##############################################################################
; ##############################################################################
; ##############################################################################
; SRAM_START= 0x0060	=    96	
; SRAM_SIZE	= 1024		=		
; RAMEND	= 0x045f	= 1.119	
STARTWERTE:
	; NULL				
	clr NULL
	; EINS				
	ldi temp,1
	mov EINS,temp
	; VOLL				
	ldi temp,0xff
	mov VOLL,temp
	; SRAM-CHECK				
	ldi temp,'S'
	STS(adr_SRAM_CHECK),temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
Watchdog_aktivieren:
	ldi TEMP,(1<<WDCE)|(1<<WDE)  
	sts wdtcsr,TEMP       
	ldi TEMP,(1<<WDE) | (1<<WDP2)|(1<<WDP1)|(1<<WDP0) 
	sts wdtcsr,temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; SRAM_START= 0x0060	=    96	
; SRAM_SIZE	= 1024		=		
; RAMEND	= 0x045f	= 1.119	
SRAM_CLEAR:
	ldi ZL, LOW (SRAM_START)
	ldi ZH, HIGH(SRAM_START)
	ldi temp,0
SRAM_CLEAR_w:
	ST z+,temp
	cpi ZH, HIGH(RAMEND-1)	; Vergleich?		
	brlo SRAM_CLEAR_w		; kleiner => SPRUNG	
	cpi ZL, LOW(RAMEND-1)	; Vergleich?		
	brlo SRAM_CLEAR_w		; kleiner => SPRUNG	
	breq SRAM_CLEAR_w		; gleich  => SPRUNG	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; PORT B+C+D CLEAR																
PORT_CLEAR:
	ldi temp, 0b00000000	
	out DDRB, temp
	out DDRC, temp
	out DDRD, temp
	out PORTB,temp				
	out PORTC,temp				
	out PORTD,temp	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
PORT_INITIALISIERUNG:
	; auf AUSGANG								
	sbi (LED_GRUEN_DDR),(LED_GRUEN_PIN_NR)		; GRN	
	sbi (LED_GELB_DDR) ,(LED_GELB_PIN_NR)		; GELB	
	sbi (LED_ROT_DDR)  ,(LED_ROT_PIN_NR)		; ROT	
/*
	sbi	PORTD,3
	sbi	DDRD,3
*/
;-------------------------------------------------------------------------------
	rcall WAIT_100ms
	LED_GRUEN_OFF
	LED_GELB_OFF
	LED_ROT_OFF
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
PROGRAMM_CHECK:
	; NULL		
	tst NULL
	brne PROGRAMM_CHECK_FEHLER
	; EINS		
	mov temp,EINS
	cpi temp,1
	brne PROGRAMM_CHECK_FEHLER
	; VOLL		
	mov temp,VOLL
	cpi temp,0xff
	brne PROGRAMM_CHECK_FEHLER
	; SRAM		
	LDS temp,(adr_SRAM_CHECK)
	cpi temp,'S'
	brne PROGRAMM_CHECK_FEHLER	
	ret
;-------------------------------------------------------------------------------
PROGRAMM_CHECK_FEHLER:
	WDR
	LED_ROT_ON
	LED_GELB_ON
	LED_GRUEN_OFF
	rcall WAIT_100ms
	LED_ROT_OFF
	LED_GELB_OFF
	rcall WAIT_100ms
	rjmp PROGRAMM_CHECK_FEHLER
; ##############################################################################
; ##############################################################################
; ##############################################################################
PROGRAMM_STOP:
	rcall WAIT_1s
	rcall WAIT_1s
	rcall WAIT_1s
	rcall WAIT_1s
;	LED_ROT_ON
	LED_GELB_ON
	LED_GRUEN_ON
	WDR
	rjmp PROGRAMM_STOP
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Version: 11/2014																
;																				
;	Division 32 bit-Zahl durch 16 bit Zahl										
;																				
;	input/Output 	temp1 (LOW)	(0...4.294.967.295)								
;	input/Output 	temp2														
;	input/Output 	temp3														
;	input/Output 	temp4 (HIGH)												
;																				
;	input	temp5	Divisor	(LOW)	 											
;	input	temp6	Divisor	(HIGH)	 											
;																				
; Register:	R0+R1	Hilfsregister 												
;			temp	Hilfsregister 												
;																				
DIVISION_32_16:
	; Fehlerprfung		
	tst temp5
	brne FUNKTION_DIVISION_32_16_RUN
	tst temp6
	brne FUNKTION_DIVISION_32_16_RUN
	; Fehler NULL		
	clr temp1
	clr temp2
	clr temp3
	clr temp4
	ret	
;-------------------------------------------------------------------------------
FUNKTION_DIVISION_32_16_RUN:
	push R0
	push R1
	push temp
	; RUNDEN halben Divisor dazuaddieren
	mov R0,temp5		; KOPIE			
	mov R1,temp6
	LSR R1				; durch 2		
	ROR r0
	add temp1,R0		; addieren		
	adc temp2,R1
	adc temp3,NULL
	adc temp4,NULL
;-------------------------------------------------------------------------------
	ldi     temp,32    ;32* schieben	
    clr     R0          ;Rest =0		
    clr     R1
FUNKTION_DIVISION_32_16_1:    
	lsl     temp1       ;Ein Bit aus dem Dividend ...   
    rol     temp2       ;ins Carry schieben
    rol     temp3
    rol     temp4
    rol     R0          ;Carry in den Rest schieben
    rol     R1
    brcs    FUNKTION_DIVISION_32_16_3       ;Bei berlauf von Rest, Sprung
    cp      R0,temp5       					;Solange Bits in temp1 (Rest) schieben bis >= divisor
    cpc     R1,temp6
    brcs    FUNKTION_DIVISION_32_16_2    	;Bei Rest<Divisor, die eingeschobene 0 in temp1 stehen lassen
FUNKTION_DIVISION_32_16_3:
    inc     temp1       ;Ansonsten Bit0 setzen und den Divisor vom Rest abziehen
    sub     R0,temp5
    sbc     R1,temp6
FUNKTION_DIVISION_32_16_2:
   	dec     temp       ;Das ganze 32 mal
    brne    FUNKTION_DIVISION_32_16_1
	pop temp
	pop R1
	pop R0	
ret 
; ##############################################################################
; ##############################################################################
; ##############################################################################
